
<!-- render_form_partial -->

{% set form_has_file_field = form.has_file_field() %}

{% if form.style.colors %}
<style>
  .ds-liberaform {
    background: {{ form.style.colors.background }};
    color: {{ form.style.colors.foreground }};
  }
  .ds-marked-up > blockquote {
    border-left-color: {{ form.style.colors.foreground }};
  }
</style>
{% endif %}

{# This style element is also referenced at form/js/form_style.js #}
<style id="inserted_background_image_style">
  {% if form.style.background_img %}
  @media only screen and (min-width: 576px) {
    body {
      background: url("{{form.style.background_img}}") no-repeat; background-size: cover;
     }
  }
  {% endif %}
</style>

{% if form.style.background_color %}
{# we set the body background as a attr so that it can be removed with the style 'clear' button #}
<script>
  $("body").css('background-color', "{{form.style.background_color}}")
</script>
{% endif %}

<div id="liberaform" {% if preview_only %}class="ds-liberaform-preview"{%endif%} style="display:none">

  {% if form.style.header_img %}
  <img id="header_image" onerror="this.onerror=null;style='display:none'" class="img-fluid ds-form-header-image" src="{{form.style.header_img}}" aria-hidden="true" />
  {% elif preview_only %}
  <img id="header_image" class="img-fluid ds-form-header-image" src="" style="display:none" />
  {% endif %}


  <div class="ds-liberaform">
    <div class="marked-up ds-marked-up">
      {{ form.introduction_text['html'] | safe }}
    </div>

    {% if form_has_file_field %}
    <form id="form" method="POST" enctype="multipart/form-data">
    {% else -%}
    <form id="form" method="POST">
    {% endif -%}
      {% if not g.embedded %}
      <input type="hidden" name="csrf_token" value="{{ csrf_token() }}" />
      {% endif -%}

      {% include 'form/partials/render-builder.html' %}

      {% if consents %}
      <div class="consent-container ds-consent-container">
        {% include 'common/render-consents.html' %}
      </div>
      {% endif %}

      {% if form.might_send_confirmation_email() %}
      <div class="form-group form-check confirmation-group">
        <input id="confirmation_checkbox" name="{{form.confirmation_field_name}}" class="form-check-input send-confirmation" type="checkbox" value="ok" disabled />
        <label name="{{form.confirmation_field_name}}" for="confirmation_checkbox" class="form-check-label send-confirmation">{{ _("Send me confirmation by email") }}</label>
      </div>
      {% endif -%}

      <div class="d-grid">
        <button class="btn btn-primary btn-lg mt-4" type="submit" {% if preview_only %}disabled{% endif %}>
          {{ _("Send") }}
        </button>
      </div>
    </form>
    {% if not template_preview %}
      <div class="pt-5 pb-4 align-bottom">
      {% include 'partials/footer.html' %}
      </div>
    {% endif %}
  </div>
</div>

<script>

$(function () {
  //var allowed_extensions = "{{ ', '.join(g.site.mimetypes['extensions']).upper() }}";
  var parsley_options = {
    errorsContainer: function (field) {
      return $(field.element).closest(".form-group")
    }
  };
  $('#form').parsley(parsley_options).on('field:validated', function() {
    var ok = $('.parsley-error').length === 0;
    $('.bs-callout-info').toggleClass('hidden', !ok);
    $('.bs-callout-warning').toggleClass('hidden', ok);
  })

  {% if form_has_file_field %}
  window.Parsley
  .addValidator('filemimetypes', {
    validateString: function(_value, requirement, parsleyInstance) {
      //console.log(requirement)
      if (!window.FormData) {
        return true;
      }
      var file = parsleyInstance.$element[0].files;
      if (file.length == 0) {
        return true;
      }
      var allowedMimeTypes = requirement.replace(/\s/g, "").split(',');
      return allowedMimeTypes.indexOf(file[0].type) !== -1;
    },
    requirementType: 'string',
    messages: {
      {{ g.language }}: "{{ _('File type not allowed') }}"
    }
  })
  .addValidator('maxFileSize', {
    validateString: function(_value, maxSize, parsleyInstance) {
      if (!window.FormData) {
        //alert('You are making all developers in the world cringe. Upgrade your browser!');
        return true;
      }
      var form_group = parsleyInstance.$element.closest('.form-group');
      if (form_group.length != 0){
        $(form_group).find('.file_hints').hide()
      }
      var files = parsleyInstance.$element[0].files;
      return files.length != 1 || files[0].size <= maxSize * 1024;
    },
    requirementType: 'integer',
    messages: {
      {{ g.language }}: "{{ _('The file is too large. Max. %(size)s', size = human_readable_bytes(config['MAX_MEDIA_SIZE'])) }}"
    }
  });
  {% endif %}
});
</script>
